<?php

namespace App\DataFixtures;
use App\Entity\ValeursFonciere;
use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Common\Persistence\ObjectManager;
use League\Csv\Reader;
use League\Csv\Statement;

class AppFixtures extends Fixture
{
    public function load(ObjectManager $manager)
    {
        // $product = new Product();
        // $manager->persist($product);

// recherche de la region en fonction d'un code postal v2

function region($cp)
{
        switch($cp){ 
                case   '75': return 'Ile-de-France'; break;
                case   '77': return 'Ile-de-France'; break;
                case   '78': return 'Ile-de-France'; break;
                case   '91': return 'Ile-de-France'; break;
                case   '92': return 'Ile-de-France'; break;
                case   '93': return 'Ile-de-France'; break;
                case   '94': return 'Ile-de-France'; break;
                case   '95': return 'Ile-de-France'; break;
                case   '51': return 'Champagne-Ardenne'; break;
                case   '08': return 'Champagne-Ardenne'; break;
                case   '10': return 'Champagne-Ardenne'; break;
                case   '52': return 'Champagne-Ardenne'; break;
                case   '80': return 'Picardie'; break;
                case   '02': return 'Picardie'; break;
                case   '60': return 'Picardie'; break;
                case   '76': return 'Haute-Normandie'; break;
                case   '27': return 'Haute-Normandie'; break;
                case   '45': return 'Centre'; break;
                case   '18': return 'Centre'; break;
                case   '28': return 'Centre'; break;
                case   '36': return 'Centre'; break;
                case   '37': return 'Centre'; break;
                case   '41': return 'Centre'; break;
                case   '14': return 'Basse-Normandie'; break;
                case   '50': return 'Basse-Normandie'; break;
                case   '61': return 'Basse-Normandie'; break;
                case   '21': return 'Bourgogne'; break;
                case   '58': return 'Bourgogne'; break;
                case   '71': return 'Bourgogne'; break;
                case   '89': return 'Bourgogne'; break;
                case   '59': return 'Nord-Pas-de-Calais'; break;
                case   '62': return 'Nord-Pas-de-Calais'; break;
                case   '57': return 'Lorraine'; break;
                case   '54': return 'Lorraine'; break;
                case   '55': return 'Lorraine'; break;
                case   '88': return 'Lorraine'; break;
                case   '67': return 'Alsace'; break;
                case   '68': return 'Alsace'; break;
                case   '25': return 'Franche-Comté'; break;
                case   '39': return 'Franche-Comté'; break;
                case   '70': return 'Franche-Comté'; break;
                case   '90': return 'Franche-Comté'; break;
                case   '44': return 'Pays-de-la-Loire'; break;
                case   '49': return 'Pays-de-la-Loire'; break;
                case   '53': return 'Pays-de-la-Loire'; break;
                case   '72': return 'Pays-de-la-Loire'; break;
                case   '85': return 'Pays-de-la-Loire'; break;
                case   '35': return 'Bretagne'; break;
                case   '22': return 'Bretagne'; break;
                case   '29': return 'Bretagne'; break;
                case   '56': return 'Bretagne'; break;
                case   '86': return 'Poitou-Charentes'; break;
                case   '16': return 'Poitou-Charentes'; break;
                case   '17': return 'Poitou-Charentes'; break;
                case   '79': return 'Poitou-Charentes'; break;
                case   '33': return 'Aquitaine'; break;
                case   '24': return 'Aquitaine'; break;
                case   '40': return 'Aquitaine'; break;
                case   '47': return 'Aquitaine'; break;
                case   '64': return 'Aquitaine'; break;
                case   '31': return 'Midi-Pyrénées'; break;
                case   '09': return 'Midi-Pyrénées'; break;
                case   '12': return 'Midi-Pyrénées'; break;
                case   '32': return 'Midi-Pyrénées'; break;
                case   '46': return 'Midi-Pyrénées'; break;
                case   '65': return 'Midi-Pyrénées'; break;
                case   '81': return 'Midi-Pyrénées'; break;
                case   '82': return 'Midi-Pyrénées'; break;
                case   '87': return 'Limousin'; break;
                case   '19': return 'Limousin'; break;
                case   '23': return 'Limousin'; break;
                case   '69': return 'Rhône-Alpes'; break;
                case   '01': return 'Rhône-Alpes'; break;
                case   '07': return 'Rhône-Alpes'; break;
                case   '26': return 'Rhône-Alpes'; break;
                case   '38': return 'Rhône-Alpes'; break;
                case   '42': return 'Rhône-Alpes'; break;
                case   '73': return 'Rhône-Alpes'; break;
                case   '74': return 'Rhône-Alpes'; break;
                case   '63': return 'Auvergne'; break;
                case   '03': return 'Auvergne'; break;
                case   '15': return 'Auvergne'; break;
                case   '43': return 'Auvergne'; break;
                case   '34': return 'Languedoc-Roussillon'; break;
                case   '11': return 'Languedoc-Roussillon'; break;
                case   '30': return 'Languedoc-Roussillon'; break;
                case   '48': return 'Languedoc-Roussillon'; break;
                case   '66': return 'Languedoc-Roussillon'; break;
                case   '13': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '04': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '05': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '06': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '83': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '84': return 'Provence-Alpes-Côte-d Azur'; break;
                case   '20': return 'Corse'; break;
                case   '971': return 'Guadeloupe'; break;
                case   '972': return 'Martinique'; break;
                case   '973': return 'Guyane'; break;
                case   '974': return 'La Réunion'; break;
                case   '975': return 'Saint-Pierre-et-Miquelon'; break;
                case   '976': return 'Mayotte'; break;
                case   '977': return 'Saint-Barthélemy'; break;
                case   '978': return 'Saint-Martin'; break;
                case   '986': return 'Wallis-et-Futuna'; break;
                case   '987': return 'Polynésie Française'; break;
                case   '988': return 'Nouvelle-Calédonie'; break; 
                default :
                return 'Region non renseigner';
                break;
                }
}

      for($annee= 5; $annee<10; $annee++){
            var_dump("Chargement des donnees de 201".$annee);
            $reader = Reader::createFromPath('%kernel.root_dir%/../src/Data/valeursfoncieres-201'.$annee.'.txt');
            $reader->setDelimiter("|");return
            $reader->setHeaderOffset(0);
            $manager->getConnection()->getConfiguration()->setSQLLogger(null);
            $stmt = (new Statement())->offset(0);
            $results = $stmt->process($reader);
            $numItemsLoaded = 0;
            //$results = $reader->fetchAssoc();
            // $valeur_fonc = new ValeursFonciere();
            // $manager->persist($valeur_fonc);
       
            foreach ($results as $row) {
              if($row['Code type local']== 1 || $row['Code type local']==2){
                $valeur_fonc = new ValeursFonciere();
                $valeur_fonc->setDateMutation(\DateTime::createFromFormat("d/m/Y", $row["Date mutation"]));
                $valeur_fonc->setNatureMutation($row['Nature mutation']);
                $valeur_fonc->setValeurFonciere(floatval(str_replace(',', '.', $row['Valeur fonciere'])));
                $valeur_fonc->setRegion(region((($row['Code departement']))));
                $valeur_fonc->setCodeCommune(intval($row['Code commune']));
                $valeur_fonc->setCodeTypeLocal(intval(str_replace(',', '.', $row['Code type local'])));
                $valeur_fonc->setCodeDepartement(intval($row['Code departement']));
                $valeur_fonc->setTypeLocal($row['Type local']);
                $valeur_fonc->setSurfaceReelleBati(floatval(str_replace(',', '.', $row['Surface reelle bati'])));
                $manager->persist($valeur_fonc);
                $numItemsLoaded++;
               
                if($numItemsLoaded === 99){
                    $numItemsLoaded = 0;
                    $manager->flush();
                    $manager->clear();
                }
             }
            }
            $manager->flush();
            $manager->clear();
       }
    }
}
